void gtk_window_destroy (GtkWindow *window) {
    gtk_widget_destroy (GTK_WIDGET (window));
}
void gtk_window_set_child (GtkWindow *window, GtkWidget *widget) {
    gtk_container_add (GTK_CONTAINER (window), widget);
}
void gtk_box_append (GtkBox *box, GtkWidget *child) {
    gtk_box_pack_start (box, child, TRUE, TRUE, 0);
}
void gtk_widget_add_css_class (GtkWidget *widget, const char *css_class) {
    GtkStyleContext *context = gtk_widget_get_style_context(widget);
    gtk_style_context_add_class(context, css_class);
}
void gtk_window_set_default_widget (GtkWindow *window, GtkWidget *widget) {
    gtk_widget_set_can_default (widget, TRUE);
    gtk_widget_grab_default (widget);
}

static void _compat_on_toggle_show_password (GtkToggleButton *toggle_button, GtkEntry *entry) {
  gtk_entry_set_visibility (entry, gtk_toggle_button_get_active (toggle_button));
}
GtkWidget * gtk_password_entry_new () {
    GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 8);
    GtkWidget *entry = gtk_entry_new();
    gtk_entry_set_visibility (GTK_ENTRY(entry), FALSE);
    g_object_set (entry, "placeholder-text", gettext ("Password"), "activates-default", TRUE, NULL);
    gtk_box_pack_start (GTK_BOX(vbox), entry, TRUE, TRUE, 0);
    GtkWidget *check_button = gtk_check_button_new_with_label (gettext ("Show / Hide"));
    gtk_widget_set_halign(check_button, GTK_ALIGN_END);
    gtk_widget_set_visible (check_button, FALSE);
    gtk_box_pack_start(GTK_BOX(vbox), check_button, TRUE, TRUE, 0);
    g_signal_connect (check_button, "toggled", G_CALLBACK(_compat_on_toggle_show_password), entry);
    return vbox;
}
typedef GtkEntry GtkPasswordEntry;
void gtk_password_entry_set_show_peek_icon (GtkPasswordEntry* entry, gboolean show_peek_icon) { //fake GtkPasswordEntry: GtkBox[GtkEntry,GtkCheckButton]
    GtkWidget *check_button = gtk_container_get_children (GTK_CONTAINER(entry))->next->data; //second child
    gtk_widget_set_visible (check_button, show_peek_icon);
}

const gchar * gtk_editable_get_text (GtkEditable *editable) {
    if (G_TYPE_CHECK_INSTANCE_TYPE (editable, GTK_TYPE_BOX)) {
        editable = GTK_EDITABLE(gtk_container_get_children (GTK_CONTAINER(editable))->data); //first child
    }
    return gtk_entry_get_text (GTK_ENTRY (editable));
}

GtkWidget * gtk_window_new_compat() {
    return gtk_window_new (GTK_WINDOW_TOPLEVEL);
}
void gtk_window_present_compat (GtkWindow *window) {
    gtk_widget_show_all (GTK_WIDGET(window));
    gtk_window_present (window);
}
