#include "thunar-encryption.h"

//~ https://docs.gtk.org/gobject/concepts.html
//~ /usr/share/gtk-doc/html/thunarx/index.html
//~ /usr/share/gtk-doc/html/thunarx/thunarx-writing-extensions-getting-started.html
//~ https://gitlab.xfce.org/xfce/thunar/-/blob/master/examples/tex-open-terminal/tex-open-terminal-plugin.c


G_MODULE_EXPORT void thunar_extension_initialize (ThunarxProviderPlugin *plugin);
G_MODULE_EXPORT void thunar_extension_shutdown   (void);
G_MODULE_EXPORT void thunar_extension_list_types (const GType **types,
                                                  gint        *n_types);

static GType type_list[1];


void thunar_extension_initialize (ThunarxProviderPlugin *plugin) {
    const gchar *mismatch;
    mismatch = thunarx_check_version (THUNARX_MAJOR_VERSION, THUNARX_MINOR_VERSION, THUNARX_MICRO_VERSION);
    if (G_UNLIKELY (mismatch != NULL)) {
        g_warning ("Version mismatch: %s", mismatch);
        return;
    }

    thunarx_encryption_register_type (plugin);
    type_list[0] = THUNARX_TYPE_ENCRIPTION;
}


void thunar_extension_shutdown (void) {}


void thunar_extension_list_types (const GType **types, gint *n_types) {
    *types = type_list;
    *n_types = G_N_ELEMENTS (type_list);
}

