#include <thunarx/thunarx.h>

#ifndef __THUNARX_ENCRIPTION__
#define __THUNARX_ENCRIPTION__
G_BEGIN_DECLS;

typedef struct _ThunarxEncryptionClass ThunarxEncryptionClass;
typedef struct _ThunarxEncryption ThunarxEncryption;

#define THUNARX_TYPE_ENCRIPTION (thunarx_encryption_get_type())
#define THUNARX_ENCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), THUNARX_TYPE_ENCRIPTION, ThunarxEncryption))
#define THUNARX_ENCRIPTION_CLASS(cls) (G_TYPE_CHECK_CLASS_CAST ((cls), THUNARX_TYPE_ENCRIPTION, ThunarxEncryptionClass))
#define THUNARX_IS_ENCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), THUNARX_TYPE_ENCRIPTION))
#define THUNARX_IS_ENCRIPTION_CLASS(cls) (G_TYPE_CHECK_CLASS_TYPE ((cls), THUNARX_TYPE_ENCRIPTION))
#define THUNARX_ENCRIPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), THUNARX_TYPE_ENCRIPTION, ThunarxEncryptionClass))

GType thunarx_encryption_get_type (void) G_GNUC_CONST;
void  thunarx_encryption_register_type (ThunarxProviderPlugin *plugin);

G_END_DECLS;
#endif


typedef enum { NORMAL_FOLDER = 0, EMPTY_FOLDER, FSCRYPT_FOLDER, ENCFS_FOLDER, CRYFS_FOLDER, UNLOCKED_FOLDER /*FSCRYPT*/, MOUNTED_FOLDER /*ENCFS/CRYFS*/, DO_ENCRYPT_FUSE, DO_ENCRYPT_FS} FolderStatus;
FolderStatus get_folder_status (GFile *folder);
gboolean is_cryfs (const gchar *path);
gboolean is_encfs (const gchar *path);
gboolean is_fscrypt (const gchar *path);
gboolean is_mounted (const gchar *path);
gboolean is_unlocked (const gchar *path);
gboolean is_empty (GFile *folder);
gboolean is_empty (GFile *folder);
gboolean is_fscrypt_available();
gboolean is_encfs_available();
gboolean is_cryfs_available();

void do_unlock_folder_fscrypt(const gchar *path, const gchar *password);
void do_encrypt_folder_fscrypt (const gchar *path, const gchar *password);

void do_unlock_folder_fuse (const gchar *path, const gchar *password, gboolean use_cryfs /*FALSE->encfs*/);
void do_encrypt_folder_fuse (const gchar *path, const gchar *password, gboolean use_cryfs);
#define FUSE_MOUNT_PATH "Encrypted-Data"
gchar * get_mount_path (const gchar *path);
void create_mount_directory (const char *path);
